﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using HugeFlow.CommandPattern;

namespace MashupImageSearch.Commands
{
    /// <summary>
    /// 어플리케이션 내의 커맨드를 정의하는 클래스
    /// </summary>
    public static class SearchCommands
    {
        /// <summary>
        /// 검색을 합니다.
        /// </summary>
        public static Command Search { get; set; }

        /// <summary>
        /// 이미지를 크게 보입니다.
        /// </summary>
        public static Command ShowLargeImage { get; set; }

        /// <summary>
        /// 해당 이미지가 포함된 웹문서를 새창으로 띄웁니다.
        /// </summary>
        public static Command Navigate { get; set; }

        /// <summary>
        /// 검색 서비스를 변경합니다.
        /// </summary>
        public static Command ChangeService { get; set; }

        /// <summary>
        /// 원본 이미지를 새창으로 띄웁니다.
        /// </summary>
        public static Command NavigateOriginalImage { get; set; }

        /// <summary>
        /// 정적생성자
        /// </summary>
        static SearchCommands()
        {
            Search = new Command("Search");
            Navigate = new Command("Navigate");
            ShowLargeImage = new Command("ShowLargeImage");
            ChangeService = new Command("ChangeService");
            NavigateOriginalImage = new Command("NavigateOriginalImage");
        }
    }
}
