﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace MashupImageSearch.Model
{
    public interface IPhotoService
    {
        /// <summary>
        /// 이미지를 검색어 keyword를 통해 검색해 옵니다.
        /// </summary>
        /// <param name="keyword">검색어</param>
        /// <param name="page">페이지 수 (1~)</param>
        /// <param name="perPage">페이지당 검색 결과수</param>
        void SearchImageAsync(string keyword, int page, int perPage);

        /// <summary>
        /// 검색 완료를 알려주는 이벤트
        /// </summary>
        event PhotoSearchEventHandler SearchImageCompleted;
    }
}
