﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Diagnostics;
using System.Xml.Linq;
using System.Windows.Browser;
using System.Windows.Media.Imaging;
using System.Windows.Threading;
using HugeFlow.CommandPattern;
using HugeFlow.Interface;

namespace MashupImageSearch.View
{
    public partial class ImageSearchVIew : UserControl
    {
        #region Constructors

        /// <summary>
        /// 기본생성자
        /// </summary>
        public ImageSearchVIew()
        {
            InitializeComponent();
         
            // 이벤트 연결
            Loaded += new RoutedEventHandler(Page_Loaded);
        }

        #endregion Constructors

        #region EventHandlers

        void Page_Loaded(object sender, RoutedEventArgs e)
        {
            // 블렌드에서는 작동이 안되게 하여 문제 생기지 않도록 함
            if (HtmlPage.IsEnabled == true)
            {
                // MouseWheelHelper를 생성하기 위한 타이머
                DispatcherTimer timer = new DispatcherTimer() { Interval = TimeSpan.FromMilliseconds(500) };
                timer.Tick += new EventHandler(timer_Tick);
                timer.Start();
            }

            comboService.SelectedIndex = 0;
        }

        void timer_Tick(object sender, EventArgs e)
        {
            (sender as DispatcherTimer).Stop();

            MouseWheelHelper wheel = new MouseWheelHelper(svImages);
            wheel.WheelScroll += new EventHandler<MouseWheelEventArgs>(wheel_Moved);
        }

        void wheel_Moved(object sender, MouseWheelEventArgs e)
        {
            if (e.Delta == 0)
                return;

            // 미래의 스크롤을 계산
            double futureScroll = svImages.VerticalOffset - e.Delta * 30;

            // 트리밍 (스크롤 범위를 벗어난 값이 설정되지 않도록)
            futureScroll = Math.Min(Math.Max(futureScroll, 0), svImages.ScrollableHeight);

            // 스크롤
            svImages.ScrollToVerticalOffset(futureScroll);
        }

        #endregion EventHandlers

        private void Image_ImageFailed(object sender, ExceptionRoutedEventArgs e)
        {
            ImageSearchViewModel viewModel = this.DataContext as ImageSearchViewModel;
            if (viewModel == null)
                return;

            viewModel.Message = "이미지를 찾을 수 없습니다.";
        }
    }
}
